#ifndef _BUFFERS_H
#define _BUFFERS_H

#define MIN(x,y) ( ((x)<(y))?(x):(y) )

// Returns 1 if c is either a space or a tab.
extern int is_sptab(char c);

// Returns 1 if c is either a space, a tab or a comma.
extern int is_sptabcomma(char c);

// This is identical to the strstr, except that comparing is case-insensitive
extern char *strstrcase(const char *haystack, const char *needle);

// Append src at the end of dest. Both must be '\0' terminated; *dest must be
// dynamically allocated or NULL, here we call free and malloc to reallocate
// it.
// If not enough mem this function returns NULL, and dest is untouched.
extern char *bufcat(char **dest, char *src);

// This operates between generic, non '\0' terminated buffers, copying
// everything (including '\0') up to src_len bytes.
extern char *bufncat(char **dest, int dest_len, char *src,int src_len);

#endif // _BUFFERS_H

