#ifndef _RW_H
#define _RW_H

extern int _read(int fd, char *buf, unsigned int n);
extern int _write(int fd, const char *buf, unsigned int n);

// These are blocking functions which read/write exactly n bytes
extern int _readn(int fd, void *buf, unsigned int n);
extern int _writen(int fd, const void *buf, unsigned int n);

// This one is like the _readn, but it rewrites everything to *reply_fd (if
// it's not -1). If something goes wrong while writing it sets reply_fd to -1,
// and goes on reading.
// Returned value is the number of READEN bytes.
extern int _readn_reply(int fd, void *buf, unsigned int n, int *reply_fd);

#endif // _RW_H

