# ifndef _STRUCT_H
# define _STRUCT_H

# include <const.h>

struct document
{
	char *hdr;
	char *doc;
	int doclen;
	int valid;
};

struct reply {
	int len;
	char *data;
	int valid;
};

// Cache structures

//Part of document in memory.
//One struct for host.
struct hash_doc
{
    char *header; //header
    char *path; //path on filesystem
	char *url_path; //path on url
	int port; //port on the server
    int size; //size of the doc on filesystem
};

//This struct creat the cache.
struct hash_host
{
    char *host_name;
    struct hash_doc *list[MAXDOC]; //array of document relative to host
    struct hash_host *next;
};

//This struct contain the process blocked waiting
//<host, doc> document.
struct search_dl
{
	char *doc; //doc name
	char *host; //host name
	int port; //host name
	int cont; //number of process blocked
	int sem; //semaphore
	struct search_dl *next;
	struct search_dl *prec;
};

// End of cache structures

enum 
{
	http,
	file,
	ftp
};

struct urlinfo_t {
	char proto[MAX_PROTO_LEN];
	char host[MAX_HOST_LEN];
	char resolved_host[MAX_RESOLVEDHOST_LEN];
	char path[MAX_PATH_LEN];
	char page[MAX_PAGE_LEN]; // used only for baseurl
	char query[MAX_QUERY_LEN];
	int lev;
	int stream;
	int fragment;
	int port; // if value is -1, the url is a local file (file://......)
	int prefetch; // if -1, url was requested by client, if -2 is baseurl, if 1 prefetched
	int size;
};

struct hrefurlhead
{
	struct hrefurl *first;
	union {
		struct hrefurl *last;
		int retr_level;
	} u;
};

struct hrefurl
{
	struct urlinfo_t *url;
	//int type; //BASE,A
	struct hrefurl *prev;
	struct hrefurl *next;
	struct hrefurl *nextsametype;
};

struct node 
{
	struct urlinfo_t url;
	int downloaded;
	int lev;
	struct node *son;
	struct node *bros; // brother on the right (same level)
	struct node *father;
	struct node *prev; // brother on the left (same level)
};

# endif //_STRUCT_H
