# include <unistd.h>
# include <stdlib.h>
# include <stdio.h>

# include <struct.h>
# include <list.h>

struct hrefurlhead *head;
struct hrefurlhead *stream_head;
struct hrefurlhead *lead_head;

int initqueue ()
{
	if ( (head = (struct hrefurlhead *) malloc (sizeof (struct hrefurlhead))) == NULL )
			return (0);
	if ( (stream_head = (struct hrefurlhead *) malloc (sizeof (struct hrefurlhead))) == NULL )
			return (0);
	if ( (lead_head = (struct hrefurlhead *) malloc (sizeof (struct hrefurlhead))) == NULL )
			return (0);
	head->first = head->u.last = NULL;
	lead_head->first =  NULL;
	stream_head->first = NULL;
	return (1);
}

int isempty ()
{
	if ( (head->first == NULL) && (head->u.last == NULL) )
		return (1);
	return (0);
}

int enqueue (struct urlinfo_t elem,int level)
{
	struct hrefurl *tmp;
	struct hrefurl *href;
	int lenght = 0;

	if ( (href = (struct hrefurl *) malloc (sizeof (struct hrefurl))) == NULL )
		return (0);
	if ( (href->url = (struct urlinfo_t *) malloc (sizeof (struct urlinfo_t))) == NULL )
		return (0);

	strcpy (href->url->proto,elem.proto);
	strcpy (href->url->host,elem.host);
	strcpy (href->url->resolved_host,elem.resolved_host);
	strcpy (href->url->path,elem.path);
	strcpy (href->url->page,elem.page);
	strcpy (href->url->query,elem.query);
	href->url->fragment = elem.fragment;
	href->url->port = elem.port;
	href->url->stream = elem.stream;
	href->url->prefetch = elem.prefetch;
	href->url->size = lenght;
	href->url->lev = level;
	href->prev = NULL;
	href->next = NULL;

	if (href->url->stream)
	{
		if (stream_head->first)
			stream_head->first->nextsametype = href;
		else
			stream_head->first = href;
		stream_head->u.retr_level = level;
	}
	else
	{
		if (lead_head->first)
			lead_head->first->nextsametype = href;
			
		else
			lead_head->first = href;
		lead_head->u.retr_level = level;
	}
	if (isempty())
	{
		href->next = NULL;
		href->prev = NULL;
		head->first = head->u.last = href;
		return (1);
	}
	else
	{
		tmp = head->first;
		while ( tmp->next != NULL) 
			tmp = tmp->next;
		tmp->next = href;
		href->prev = tmp;
		head->u.last = href;
		return (1);
	}
	return (0);
}	

struct hrefurl *extract_stream()
{
	struct hrefurl *ret;
	
	if (!(stream_head->first))
		return (NULL);
	else
		ret = stream_head->first;
	return (ret);
}		

struct hrefurl *extract_lead()
{
	struct hrefurl *ret;
	
	if (!(lead_head->first))
	{
		return (NULL);
	}
	else
		ret = lead_head->first;

	return (ret);
}		

int dequeue (struct hrefurl *tmp)
{
	if ( !tmp )
		return (0);
	else
	{
		/* update pointer of stream and lead head */
		if ( (tmp->url->stream) && (stream_head != NULL) &&
		     (stream_head->first != NULL) )
			stream_head->first = stream_head->first->next;	
		else if ( (lead_head != NULL) && (lead_head->first != NULL) )
			lead_head->first = lead_head->first->next;	
		/* delete element from list */
		if (head->u.last == head->first) // unique element in the list
		{
			head->first = NULL;
			head->u.last = NULL;
			free(tmp);
			return (1);
		}
		else if ( head->first == tmp ) // first element
		{
			head->first = tmp->next;
			head->first->prev = NULL;
			free(tmp);
			return (1);
		}
		else if ( head->u.last == tmp ) // last element
		{
			head->u.last = tmp->prev;
			head->u.last->next = NULL;
			free(tmp);
			return (1);
		}
		else // middle element
		{
			if (tmp->next != NULL)
				tmp->next->prev = tmp->prev;
			if (tmp->prev != NULL)
				tmp->prev->next = tmp->next;
			return (1);
		}
	}
	return (0);
}
