#include <time.h>
#include <stdlib.h>

#ifndef LOG_TO_SCREEN

#include <unistd.h>

#endif

#ifdef NONBLOCKING_RW

#include <stdio.h>

#endif

#include <hash.h>
#include <proxy_main.h>
#include <init_shared.h>
#include <logging.h>

int main()
{
#ifndef LOG_TO_SCREEN
	int f_ret;
#endif

#ifdef NONBLOCKING_RW
	fprintf(stderr,"Warning: this version of " NAME " has been compiled\n");
	fprintf(stderr,"with the option NONBLOCKING_RW. This feature is still\n");
	fprintf(stderr,"untested, use it at your own risk.\n");
#endif

	srandom(time(NULL));

#ifndef LOG_TO_SCREEN
	if ((f_ret=fork()) == 0)
	{
		setsid();
#endif
		if (proxy_main())
		{
			finish_hash();
			detach_shmem();
			drop_shmem();
		}
#ifndef LOG_TO_SCREEN
	}
	else if (f_ret<0)
	{
		log(LOG_ERR,"main: cannot fork into background");
		return 1;
	}
#endif

	return 0;
}

