#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>

#include <logging.h>
#include <const.h>

#define SHM_TRIES 10

char *shmem_start;
unsigned int shmem_size=0;
int shm_id;

int init_shared()
{
	int i;

	shm_id = -1;
	for (i=0;(i<SHM_TRIES) && (shm_id==-1);i++)
	{
		unsigned int shm_key;

		shm_key = (unsigned int)(random());
		shm_id=shmget(shm_key,SHM_SIZE,IPC_CREAT|IPC_EXCL|0600);
	}

	if ( shm_id == -1 )
	{
		log(LOG_ERR,"init_shared: Cannot get shared memory");
		return 0;
	}

	if ( (shmem_start=shmat(shm_id,0,0)) == (char*)-1 )
	{
		shmctl(shm_id,IPC_RMID,NULL);
		log(LOG_ERR,"init_shared: Cannot get pointer to shared memory");
		return 0;
	}

	for (i=0;i<4;i++)
		*(shmem_start+i)=0;

	shmem_size=SHM_SIZE;
	return 1;
}

int attach_shmem()
{
	shmem_start=shmat(shm_id,0,0);
	shmem_size=SHM_SIZE;
	return (shmem_start != (char *)-1);
}

int detach_shmem()
{
	return (shmdt(shmem_start) == 0);
}

void drop_shmem()
{
	shmctl(shm_id,IPC_RMID,NULL);
}

