#include <stdlib.h>
#include <string.h>

// Returns 1 if c is either a space or a tab.
int is_sptab(char c)
{
	return ( (c=='\t') || (c==' ') );
}

// Returns 1 if c is either a space, a tab or a comma.
int is_sptabcomma(char c)
{
	return ( (c=='\t') || (c==' ') || (c==','));
}

// This is identical to the strstr, except that comparing is case-insensitive
char *strstrcase(const char *haystack, const char *needle)
{
	char *ptr;

	ptr = (char *)haystack;

	while (*ptr != '\0')
	{
		if (strncasecmp(ptr,needle,strlen(needle)) == 0)
			return ptr;
		ptr++;
	}

	return NULL;
}

// Append src at the end of dest. Both must be '\0' terminated; *dest must be
// dynamically allocated or NULL, here we call free and malloc to reallocate
// it.
// If not enough mem this function returns NULL, and dest is untouched.
char *bufcat(char **dest, char *src)
{
	char *tmp;

	if ( (tmp=malloc((*dest==NULL?0:strlen(*dest)) + strlen(src) + 1)) == NULL )
	{
		return NULL;
	}

	// Must be safe if *dest is NULL
	if (*dest != NULL)
		strcpy(tmp,*dest);
	else
		*tmp='\0';

	strcat(tmp,src);

	free(*dest);
	*dest=tmp;

	return tmp;
}

// This operates between generic, non '\0' terminated buffers, copying
// everything (including '\0') up to src_len bytes.
char *bufncat(char **dest, int dest_len, char *src, int src_len)
{
	char *tmp;

	if ( (tmp=malloc((*dest==NULL?0:dest_len) + src_len)) == NULL )
	{
		return NULL;
	}

	// Must be safe if *dest is NULL
	if (*dest != NULL)
		memcpy(tmp,*dest,dest_len);
	else
		dest_len=0;

	memcpy(tmp+dest_len,src,src_len);

	free(*dest);
	*dest=tmp;

	return tmp;
}

