#include <syslog.h>
#include <stdarg.h>

#ifdef LOG_TO_SCREEN

#include <stdio.h>
#include <unistd.h>

#endif

#define LOG_NAME NAME

// Write logs, to syslog if process started in background,
// on the consol otherwise.
void log(int err, const char *format, ...)
{
	va_list args;

	va_start(args,format);

#ifdef LOG_TO_SCREEN
	fprintf(stderr,"%d ",getpid());
	vfprintf(stderr,format,args);
	fprintf(stderr,"\n");
#else
	openlog(LOG_NAME, LOG_PID, LOG_DAEMON);
	vsyslog(err, format, args);
#endif

	va_end(args);
	closelog();
}

